/*
    Quick Log Entry (qle)
    Copyright (C) 2025  Thomas Cort

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later
 */

#ifndef QLE_FMT_H
#define QLE_FMT_H

#include <stdio.h>
#include <time.h>

enum qle_fmt_t {
	QLE_FMT_ADIF,
	QLE_FMT_ADIF_COMPACT,
	QLE_FMT_ADIF_NO_HEADER,
	QLE_FMT_CABRILLO
};

int qle_qso_datetime_is_after(char *after);
int qle_qso_datetime_is_before(char *before);

int qle_fmt_header(enum qle_fmt_t fmt, FILE *input, FILE *output, FILE *error, time_t input_mtime, char *input_file);
void qle_fmt_record(enum qle_fmt_t fmt, FILE *output, char *after, char *before);
void qle_fmt_footer(enum qle_fmt_t fmt, FILE *output);

#endif
