/*
    Quick Log Entry (qle)
    Copyright (C) 2025  Thomas Cort

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <regex.h>
#include <string.h>

#include "re.h"

int qle_match(char *subject, char *pattern) {

	int rc;
	regex_t preg;
	regmatch_t matches[1];
	size_t nmatches =  1;

	memset(&preg, '\0', sizeof(regex_t));
	rc = regcomp(&preg, pattern, REG_EXTENDED|REG_ICASE);
	if (rc != 0) {
		return -1;
	}

	memset(matches, '\0', sizeof(regmatch_t));
	rc = regexec(&preg, subject, nmatches, matches, 0);
	regfree(&preg);

	switch (rc) {
		case REG_NOMATCH: return 0;
		case 0: return 1;
		default: return -1;
	}

}

